#Compiler PBWin 10
#Compile Exe "gbfileviewer.exe"
#Dim All
#Include "win32api.inc"
#Resource Icon fave, "images\favicon.ico"

$ver = "1.1"

%ID_Path = 100 : %ID_FileList = 101 : %ID_Content = 102 : %ID_SelectFolder = 103 : %ID_YesNo = 110
%ID_Kill = 104 : %ID_bas = 105 : %ID_txt = 106 : %ID_rc = 107 : %ID_inc = 108 : %ID_star = 109 : %ID_save = 111
Global hDlg As Dword, DArray() As String, FileList(), cFolder As String, style&

Function PBMain() As Long
    Dialog New Pixels, 0, "Text File Viewer  " + $ver,300,300,400,400, %WS_OverlappedWindow To hDlg
    Dialog Set Icon hDlg, "fave"
    Control Add Button, hDlg, %ID_SelectFolder, "Select Folder", 10,10,100,20
    Control Add Label, hDlg, %ID_Path, "", 170,10,200,20, %WS_Border
    Control Add ListBox, hDlg, %ID_FileList,DArray(), 10,40,150,280 Call ListBoxProc
    Control Add CheckBox, hDlg, %ID_txt, "txt", 10,310,50,10 Call CheckBoxProc
    Control Add CheckBox, hDlg, %ID_bas, "bas", 70,310,50,10 Call CheckBoxProc
    Control Add CheckBox, hDlg, %ID_inc, "inc", 10,330,50,10 Call CheckBoxProc
    Control Add CheckBox, hDlg, %ID_rc, "rc", 70,330,50,10   Call CheckBoxProc
    Control Add CheckBox, hDlg, %ID_star, "*.*", 10,350,50,10   Call CheckBoxProc
    Control Add CheckBox, hDlg, %ID_yesno, "Y/N", 70,350,50,10

    Control Set Check hDlg, %ID_txt, 1
    Control Set Check hDlg, %ID_bas, 1
    Control Set Check hDlg, %ID_YesNo, 1

    style& = %WS_Border Or %ES_Left Or %ES_AutoHScroll Or %ES_MultiLine Or %WS_Ex_ClientEdge _
             Or %ES_WantReturn Or %ES_AutoVScroll Or %WS_HScroll Or %WS_VScroll Or %WS_Ex_Left
    Control Add TextBox, hDlg, %ID_Content,"<file content>", 170,40,200,350, style&
    Control Add Button, hDlg, %ID_Kill,"Delete", 10,370,70,20
    Control Add Button, hDlg, %ID_Save,"Save", 90,370,70,20
    Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function ListBoxProc() As Long
    If Cb.Msg = %WM_Command And Cb.CtlMsg = %LBN_SelChange Then
        Dim iSelect&, Selection$
        ListBox Get Select hDlg, %ID_FileList To iSelect&
        ListBox Get Text hDlg, %ID_FileList To Selection$
        LoadSelection (Selection$)
    End If
End Function

CallBack Function CheckBoxProc() As Long
    If Cb.Msg = %WM_Command And Cb.CtlMsg = %BN_Clicked Then  RefreshFileList
End Function

CallBack Function DlgProc() As Long
   Dim iCheck As Long
   Select Case Cb.Msg
        Case %WM_Create

        Case %WM_InitDialog
            Settings_INI "get"
            Control Set Text hDlg, %ID_Path, cfolder
            RefreshFileList

        Case %WM_Destroy
            'store current settings
            Settings_INI "set"

        Case %WM_Size
            Dim w As Long, h As Long
            Dialog Get Client hDlg To w,h
            Control Set Size hDlg, %ID_Content, w - 175, h - 45
            Control Set Size hDlg, %ID_Path, w - 175, 20
            Control Set Text hDlg, %ID_Path, cFolder

        Case %WM_GetMinMaxInfo
            Dim MM As MINMAXINFO Ptr
            MM=Cb.LParam
            @MM.ptMinTrackSize.x=400  '<-- Min. size
            @MM.ptMinTrackSize.y=430  '<-- Max. size

        Case %WM_Command
            Select Case Cb.Ctl
                Case %ID_SelectFolder
                   If Cb.CtlMsg = %BN_Clicked Then
                      SelectFolder(cFolder)
                      Control Set Text hDlg, %ID_Path, cFolder
                      RefreshFileList
                   End If
                Case %ID_Kill
                   If Cb.CtlMsg = %BN_Clicked Then
                       Control Get Check hDlg, %ID_yesno To iCheck
                       If iCheck Then
                           If MsgBox("Are you sure?", %MB_OkCancel Or %MB_IconWarning , "Delete File") = %IdOk Then KillFile
                        Else
                           KillFile
                       End If
                   End If
                Case %ID_Save
                   If Cb.CtlMsg = %BN_Clicked Then
                       Control Get Check hDlg, %ID_yesno To iCheck
                       If iCheck Then
                           If MsgBox("Are you sure?", %MB_OkCancel Or %MB_IconWarning , "Save File") = %IdOk Then Savefile
                        Else
                           Savefile
                       End If
                   End If
            End Select
    End Select
End Function

Sub SelectFolder(StartPath$)
    Dim Flags&, SelectedFolder$
    Flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
    Display Browse  hDlg, 100,100,"", StartPath$, Flags& To SelectedFolder$
    If SelectedFolder$ <> "" Then
        If Right$(SelectedFolder$,1) = "\" Then
            StartPath$ = SelectedFolder$
        Else
            StartPath$ = SelectedFolder$ + "\"
        End If
    End If
End Sub

Function RefreshFileList() As Long
    Dim bas&, Txt&, rc&, inc&, star&, iCount&
    Control Get Check hDlg, %ID_bas To bas&
    Control Get Check hDlg, %ID_txt To Txt&
    Control Get Check hDlg, %ID_rc To rc&
    Control Get Check hDlg, %ID_inc To inc&
    Control Get Check hDlg, %ID_star To star&
    ListBox Reset hDlg, %ID_FileList
    Control Set Text hDlg, %ID_Content, ""

    Dim temp$
    temp$ = Dir$(cfolder + "*.*")
    If Len(temp$) = 0 Then
        Exit Function
    Else
        While Len(temp$)
            If star& Then
                ListBox Add hDlg, %ID_FileList, temp$
            Else
                If bas& And Right$(temp$,4)=".bas" Then ListBox Add hDlg, %ID_FileList, temp$
                If Txt& And Right$(temp$,4)=".txt" Then ListBox Add hDlg, %ID_FileList, temp$
                If rc& And Right$(temp$,4)=".rc" Then ListBox Add hDlg, %ID_FileList, temp$
                If inc& And Right$(temp$,4)=".inc" Then ListBox Add hDlg, %ID_FileList, temp$
            End If
            temp$ = Dir$(Next)
        Wend
    End If

    ListBox Get Count hDlg, %ID_FileList To iCount&
    If iCount& Then
        ListBox Select hDlg, %ID_FileList, 1
        ListBox Get Text hDlg, %ID_FileList To temp$
        LoadSelection temp$
    End If

End Function

Sub LoadSelection(f As String)
    If IsFile(cFolder + f) Then
        Dim filedata$
        Open cFolder + f For Binary As #1
        Get$ #1, Lof(1), filedata$
        Close #1
        Control Set Text hDlg, %ID_Content, filedata$
    Else
        Control Set Text hDlg, %ID_Content, "<file not found>"
    End If
End Sub

Sub Savefile
    Dim temp$, Content$
    ListBox Get Text hDlg, %ID_FileList To temp$
    If IsFile(cFolder + temp$) Then
        Open cfolder+temp$ For Output As #1
        Control Get Text hDlg, %ID_Content To Content$
        Print #1, Content$
        Close #1
    End If
    'remove that item from listbox
End Sub

Sub KillFile
    Dim temp$, iSelect&, iCount&
    ListBox Get Text hDlg, %ID_FileList To temp$
    ListBox Get Select hDlg, %ID_FileList To iSelect&
    If IsFile(cFolder + temp$) Then
        ListBox Delete hDlg, %ID_FileList, iSelect&
        Kill cFolder + temp$
        ListBox Get Count hDlg, %ID_FileList To iCount&
        If iCount& Then
            If iSelect& > iCount& Then iSelect& = iCount&
            ListBox Select hDlg, %ID_FileList, iSelect&
            ListBox Get Text hDlg, %ID_FileList To temp$
            LoadSelection temp$
        End If
    End If
    'remove that item from listbox
End Sub

Sub CPrint (SOut As String)    'Semen Matusovski's CPrint code:
    Static hConsole As Long, cWritten As Long
    If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
    WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
End Sub

Sub Settings_INI(Task$)

    Local x As Long, y As Long, iCheck As Long
    Local xResult As AsciiZ*256, yResult As AsciiZ*256
    Local temp As AsciiZ*256, INIFileName As AsciiZ*256

    INIFileName = Exe.Path$ + "gbFileViewer.ini"

    If InStr(Command$,"\clear") Then Kill INIFileName

    If Task$ = "get" Then
        '... save values by assigning to V()
        GetPrivateProfileString "All", "dWidth", "300", xResult, 256, INIFileName
        GetPrivateProfileString "All", "dHeight", "300", yResult, 256, INIFileName
        If Val(xResult) < 1 Then xResult = "300"
        If Val(yResult) < 1 Then yResult = "300"
        Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

        Getprivateprofilestring "All", "dLeft", "300", xResult, 256, INIFileName
        Getprivateprofilestring "All", "dTop", "300", yResult, 256, INIFileName
        If Val(xResult) < 1 Then xResult = "330"
        If Val(yResult) < 1 Then yResult = "400"
        Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

        Getprivateprofilestring "All", "BAS", "", temp, 256, INIFileName
        Control Set Check hDlg, %ID_bas, Val(temp)
        Getprivateprofilestring "All", "TXT", "", temp, 256, INIFileName
        Control Set Check hDlg, %ID_txt, Val(temp)
        Getprivateprofilestring "All", "INC", "", temp, 256, INIFileName
        Control Set Check hDlg, %ID_inc, Val(temp)
        Getprivateprofilestring "All", "RC", "", temp, 256, INIFileName
        Control Set Check hDlg, %ID_rc, Val(temp)
        Getprivateprofilestring "All", "STAR", "", temp, 256, INIFileName
        Control Set Check hDlg, %ID_star, Val(temp)
        Getprivateprofilestring "All", "YESNO", "", temp, 256, INIFileName
        Control Set Check hDlg, %ID_yesno, Val(temp)

        Getprivateprofilestring "All", "CFOLDER", "", temp, 256, INIFileName
        If temp = "" Then
            cfolder = Exe.Path$
        Else
            cfolder = temp
        End If

    Else    'set'
        If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
            Dialog Get Size hDlg To x,y
            WritePrivateProfileString "All", "dWidth", Str$(x), INIFileName
            WritePrivateProfileString "All", "dHeight", Str$(y), INIFileName
            Dialog Get Loc hDlg To x,y
            WritePrivateProfileString "All", "dLeft", Str$(x), INIFileName
            WritePrivateProfileString "All", "dTop", Str$(y), INIFileName
        End If

        Control Get Check hDlg, %ID_bas To iCheck
        temp = Str$(iCheck)
        WritePrivateProfileString "All", "BAS", temp, INIFileName

        Control Get Check hDlg, %ID_txt To iCheck
        temp = Str$(iCheck)
        WritePrivateProfileString "All", "TXT", temp, INIFileName

        Control Get Check hDlg, %ID_inc To iCheck
        temp = Str$(iCheck)
        WritePrivateProfileString "All", "INC", temp, INIFileName

        Control Get Check hDlg, %ID_rc To iCheck
        temp = Str$(iCheck)
        WritePrivateProfileString "All", "RC", temp, INIFileName

        Control Get Check hDlg, %ID_star To iCheck
        temp = Str$(iCheck)
        WritePrivateProfileString "All", "STAR", temp, INIFileName

        Control Get Check hDlg, %ID_yesno To iCheck
        temp = Str$(iCheck)
        WritePrivateProfileString "All", "YESNO", temp, INIFileName

        temp = cfolder
        WritePrivateProfileString "All", "CFOLDER", temp, INIFileName

     End If

End Sub
